steamguard-cli/scripts/full-release.sh

127 lines
3.3 KiB
Bash
Raw Permalink Normal View History

#!/bin/bash
set -e
DRY_RUN=true
2021-08-25 19:04:06 +02:00
SKIP_CRATE_PUBLISH=false
2023-09-04 19:39:27 +02:00
ALLOW_DIRTY=false
POSITIONAL=()
while [[ $# -gt 0 ]]; do
key="$1"
case $key in
--execute)
DRY_RUN=false
shift # past argument
;;
--bump)
BUMP="$2"
shift # past argument
shift # past value
;;
2021-08-25 19:04:06 +02:00
--skip-publish)
SKIP_CRATE_PUBLISH=true
shift # past argument
;;
2023-09-04 19:39:27 +02:00
--allow-dirty)
ALLOW_DIRTY=true
shift # past argument
;;
*) # unknown option
POSITIONAL+=("$1") # save it in an array for later
shift # past argument
;;
esac
done
current_branch=$(git rev-parse --abbrev-ref HEAD)
if [[ "$current_branch" != "master" ]]; then
echo "You must be on the master branch to run this script"
exit 1
fi
git pull
echo """
This will do everything needed to release a new version:
- bump the version number
- create a git tag
- build all artifacts
- publish crates on crates.io
- upload artifacts to a new release on github
"""
2023-12-03 17:43:31 +01:00
echo "Previewing changes..."
2024-03-04 23:17:38 +01:00
params=()
if [[ $BUMP != "" ]]; then
params+=(--bump "$BUMP")
params+=(--bump-dependencies "$BUMP")
fi
if [[ $SKIP_CRATE_PUBLISH == true ]]; then
params+=(--no-publish)
fi
if [[ $ALLOW_DIRTY == true ]]; then
params+=(--allow-dirty)
fi
cargo smart-release --update-crates-index --no-changelog --no-tag --no-push --no-publish "${params[@]}"
2023-12-03 17:43:31 +01:00
if [ "$DRY_RUN" = true ]; then
echo "This is a dry run, nothing will be done. Artifacts will be built, but not published. Use --execute to do it for real."
else
echo "This is not a dry run. This is the real deal!"
fi
echo "Press any key to continue..."
read -n 1 -s -r
2024-03-04 23:17:38 +01:00
if [[ $DRY_RUN == false ]]; then
params+=(--execute)
fi
2023-07-01 13:15:20 +02:00
cargo smart-release --update-crates-index --no-changelog --no-tag --no-push --no-publish "${params[@]}"
#echo "Verify that the publish succeeded, and Press any key to continue..."
# read -n 1 -s -r
if ! which cross; then
echo "cross not found, installing..."
cargo install cross
fi
BUILD_TARGET="x86_64-unknown-linux-musl"
BUILD_TARGET2="x86_64-pc-windows-gnu"
2023-06-30 00:49:03 +02:00
# HACK: build targets in this order to avoid a bug in cross
cross build --release "--target=$BUILD_TARGET2"
2023-06-30 00:49:03 +02:00
cross build --release "--target=$BUILD_TARGET"
./scripts/package-deb.sh
BIN_PATH="target/$BUILD_TARGET/release/steamguard"
BIN_PATH2="target/$BUILD_TARGET2/release/steamguard.exe"
RAW_VERSION="$("$BIN_PATH" --version | cut -d " " -f 2)"
2023-07-02 13:39:46 +02:00
# TODO: can't compare with the tag anymore because it doesn't exist yet. maybe get a better condition?
# TAGGED_VERSION="$(git tag | grep "^v" | tail -n 1 | tr -d v)"
# if [[ "v$RAW_VERSION" != "v$TAGGED_VERSION" ]]; then
# echo "Version mismatch: $RAW_VERSION != $TAGGED_VERSION"
# if [[ $DRY_RUN == false ]]; then
# echo "Aborting."
# exit 2
# fi
# fi
VERSION="v$RAW_VERSION"
2023-06-30 16:58:30 +02:00
echo "It's now safe to push tags and publish for the affected crates."
if [[ $DRY_RUN == false ]]; then
2023-07-02 13:39:46 +02:00
cargo smart-release --update-crates-index --no-changelog --execute
2023-06-30 16:58:30 +02:00
fi
if [[ $DRY_RUN == false ]]; then
if [[ $(gh release list | grep -i "Draft" | grep -i "$VERSION" && echo "true" || echo "false") == "true" ]]; then
gh release delete --yes "$VERSION"
fi
2023-07-09 17:09:08 +02:00
gh release create "$VERSION" --discussion-category "General" --title "$VERSION" "$BIN_PATH" "$BIN_PATH2" "./steamguard-cli_$RAW_VERSION-0.deb"
fi